xfs
[Top] [All Lists]

[PATCH v3] xfstests: add specific test for default ACL inheritance

To: linux-btrfs@xxxxxxxxxxxxxxx, xfs@xxxxxxxxxxx
Subject: [PATCH v3] xfstests: add specific test for default ACL inheritance
From: Filipe David Borba Manana <fdmanana@xxxxxxxxx>
Date: Wed, 16 Oct 2013 17:25:18 +0100
Cc: jbacik@xxxxxxxxxxxx, dsterba@xxxxxxx, sandeen@xxxxxxxxxxx, Filipe David Borba Manana <fdmanana@xxxxxxxxx>
Delivered-to: xfs@xxxxxxxxxxx
Dkim-signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113; h=from:to:cc:subject:date:message-id:in-reply-to:references; bh=B4IoIHhmQd0PMt/NrIREwt9ZxF8ajOS2Z+lBEMIc8NU=; b=eDaNzrJHeSqN5IKaC2l43vkuT2LsB8gFzk/bPVByi9M4h0bU1Tx6M0VuumO5Z+yEmv ofB27oO8hdUECJxUCunoeJViT/OOOzDuApDArBtJPb/8+e983D/giyOEtVCurrDg/FGI 027Ix8gnH0GGRBX3IIFhX55yRzssB1BZmxTM8Rvl9gD0HwWiVQAJVchoGLRbXNPhkFfx I0FwtppMCQGfHe/gBhSI3pAVbhzHRrGK4bAvnf4lRifOdGzF/7r5WrBbhzMtEVtAUcEm b/QZafwAND+dTyoZlhgNlybC8KwObVJ5fYxu8iV68Br1Qx5X86WQEm8XgGKBa3pU9Hfk QxsA==
In-reply-to: <1381932296-14674-1-git-send-email-fdmanana@xxxxxxxxx>
References: <1381932296-14674-1-git-send-email-fdmanana@xxxxxxxxx>
This test is motivated by an issue found by a btrfs user, addressed
and described by the following Linux kernel patch:

https://patchwork.kernel.org/patch/3046931/

The steps to reproduce the issue on btrfs are the following:

$ mkfs.btrfs -f /dev/loop0
$ mount /dev/loop0 /mnt
$ mkdir /mnt/acl
$ setfacl -d --set u::rwx,g::rwx,o::- /mnt/acl
$ getfacl /mnt/acl
user::rwx
group::rwx
other::r-x
default:user::rwx
default:group::rwx
default:other::---

$ mkdir /mnt/acl/dir1
$ getfacl /mnt/acl/dir1
user::rwx
group::rwx
other::---

After unmounting and mounting again the filesystem, getfacl returned the
expected default ACL for the subdirectory:

$ umount /mnt/acl
$ mount /dev/loop0 /mnt
$ getfacl /mnt/acl/dir1
user::rwx
group::rwx
other::---
default:user::rwx
default:group::rwx
default:other::---

This means that the underlying ACL xattr was persisted correctly but
the in memory representation of the inode had (incorrectly) a NULL ACL.

Signed-off-by: Filipe David Borba Manana <fdmanana@xxxxxxxxx>
---

V2: Moved the regression test into a dedicated and new file, as suggested
    by Eric Sandeen.
V3: Moved the test to the generic group and added "_supported_fs generic",
    as suggested by Eric Sandeen. Also replaced GNU/Linux with Linux (hope
    rms doesn't get mad at me).

 tests/generic/106     |   71 +++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/106.out |   21 +++++++++++++++
 tests/generic/group   |    1 +
 3 files changed, 93 insertions(+)
 create mode 100755 tests/generic/106
 create mode 100644 tests/generic/106.out

diff --git a/tests/generic/106 b/tests/generic/106
new file mode 100755
index 0000000..76cea80
--- /dev/null
+++ b/tests/generic/106
@@ -0,0 +1,71 @@
+#! /bin/bash
+# FS QA Test No. generic/106
+#
+# Regression test to make sure a directory inherits the default ACL from
+# its parent directory. This test was motivated by an issue reported by
+# a btrfs user. That issue is fixed and described by the following btrfs
+# kernel patch:
+#
+#     https://patchwork.kernel.org/patch/3046931/
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Filipe Manana.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1       # FAILure is the default!
+
+_cleanup()
+{
+       rm -f $tmp.*
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs generic
+_require_acls
+_require_scratch
+_need_to_be_root
+
+rm -f $seqres.full
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount
+
+mkdir $SCRATCH_MNT/testdir
+setfacl -d --set u::rwx,g::rwx,o::- $SCRATCH_MNT/testdir
+getfacl --absolute-names $SCRATCH_MNT/testdir | _filter_scratch
+
+mkdir $SCRATCH_MNT/testdir/testsubdir
+getfacl --absolute-names $SCRATCH_MNT/testdir/testsubdir | _filter_scratch
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/106.out b/tests/generic/106.out
new file mode 100644
index 0000000..5755cf9
--- /dev/null
+++ b/tests/generic/106.out
@@ -0,0 +1,21 @@
+QA output created by 106
+# file: SCRATCH_MNT/testdir
+# owner: root
+# group: root
+user::rwx
+group::r-x
+other::r-x
+default:user::rwx
+default:group::rwx
+default:other::---
+
+# file: SCRATCH_MNT/testdir/testsubdir
+# owner: root
+# group: root
+user::rwx
+group::rwx
+other::---
+default:user::rwx
+default:group::rwx
+default:other::---
+
diff --git a/tests/generic/group b/tests/generic/group
index 1aee03c..e93233a 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -33,6 +33,7 @@
 099 udf auto
 100 udf auto
 105 acl auto quick
+106 acl auto quick
 112 rw aio auto quick
 113 rw aio auto quick
 117 attr auto quick
-- 
1.7.9.5

<Prev in Thread] Current Thread [Next in Thread>